"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const qwik = require("@builder.io/qwik");
const accordionRootContextId = qwik.createContextId("accordion-root");
const accordionItemContextId = qwik.createContextId("accordion-item");
const AccordionRoot = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const props1 = qwik._restProps(props, [
    "collapsible",
    "behavior",
    "animated",
    "onSelectedIndexChange$",
    "onFocusIndexChange$"
  ]);
  const rootRef = qwik.useSignal();
  const currFocusedTriggerIndexSig = qwik.useSignal(-1);
  const currSelectedTriggerIndexSig = qwik.useSignal(-1);
  const selectedTriggerIdSig = qwik.useSignal("");
  const triggerElementsSig = qwik.useSignal([]);
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track }) => {
    const [currSelectedTriggerIndexSig2, props2] = qwik.useLexicalScope();
    track(() => currSelectedTriggerIndexSig2.value);
    if (props2.onSelectedIndexChange$)
      props2.onSelectedIndexChange$(currSelectedTriggerIndexSig2.value);
  }, "AccordionRoot_component_useTask_KStbWcJiHDc", [
    currSelectedTriggerIndexSig,
    props
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track }) => {
    const [currFocusedTriggerIndexSig2, props2] = qwik.useLexicalScope();
    track(() => currFocusedTriggerIndexSig2.value);
    if (props2.onFocusIndexChange$)
      props2.onFocusIndexChange$(currFocusedTriggerIndexSig2.value);
  }, "AccordionRoot_component_useTask_1_JCHM450ouJg", [
    currFocusedTriggerIndexSig,
    props
  ]));
  const updateTriggers$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [rootRef2, triggerElementsSig2] = qwik.useLexicalScope();
    if (!rootRef2.value)
      return;
    const getLatestTriggers = Array.from(rootRef2.value.querySelectorAll("[data-trigger-id]"));
    triggerElementsSig2.value = getLatestTriggers.filter((element) => {
      if (element.getAttribute("aria-disabled") === "true")
        return false;
      return true;
    });
  }, "AccordionRoot_component_updateTriggers_fUk8NsJrCnc", [
    rootRef,
    triggerElementsSig
  ]);
  const focusPreviousTrigger$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [currFocusedTriggerIndexSig2, triggerElementsSig2] = qwik.useLexicalScope();
    if (currFocusedTriggerIndexSig2.value === 0) {
      currFocusedTriggerIndexSig2.value = triggerElementsSig2.value.length - 1;
      return triggerElementsSig2.value[triggerElementsSig2.value.length - 1].focus();
    }
    currFocusedTriggerIndexSig2.value--;
    return triggerElementsSig2.value[currFocusedTriggerIndexSig2.value].focus();
  }, "AccordionRoot_component_focusPreviousTrigger_rbafaRXpeyQ", [
    currFocusedTriggerIndexSig,
    triggerElementsSig
  ]);
  const focusNextTrigger$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [currFocusedTriggerIndexSig2, triggerElementsSig2] = qwik.useLexicalScope();
    if (currFocusedTriggerIndexSig2.value === triggerElementsSig2.value.length - 1) {
      currFocusedTriggerIndexSig2.value = 0;
      return triggerElementsSig2.value[0].focus();
    }
    currFocusedTriggerIndexSig2.value++;
    return triggerElementsSig2.value[currFocusedTriggerIndexSig2.value].focus();
  }, "AccordionRoot_component_focusNextTrigger_noTlucrJNlc", [
    currFocusedTriggerIndexSig,
    triggerElementsSig
  ]);
  const focusFirstTrigger$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [triggerElementsSig2] = qwik.useLexicalScope();
    return triggerElementsSig2.value[0].focus();
  }, "AccordionRoot_component_focusFirstTrigger_knwiaPc8ULo", [
    triggerElementsSig
  ]);
  const focusLastTrigger$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [triggerElementsSig2] = qwik.useLexicalScope();
    return triggerElementsSig2.value[triggerElementsSig2.value.length - 1].focus();
  }, "AccordionRoot_component_focusLastTrigger_ZnTi0nTlCE4", [
    triggerElementsSig
  ]);
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function reIndexTriggers() {
    const [updateTriggers$2] = qwik.useLexicalScope();
    updateTriggers$2();
  }, "AccordionRoot_component_useVisibleTask_WkLLBZfbPnI", [
    updateTriggers$
  ]));
  const contextService = {
    updateTriggers$,
    focusFirstTrigger$,
    focusPreviousTrigger$,
    focusNextTrigger$,
    focusLastTrigger$,
    currFocusedTriggerIndexSig,
    currSelectedTriggerIndexSig,
    selectedTriggerIdSig,
    triggerElementsSig,
    collapsible: props.collapsible ?? true,
    behavior: props.behavior ?? "single",
    animated: props.animated ?? false
  };
  qwik.useContextProvider(accordionRootContextId, contextService);
  return /* @__PURE__ */ qwik._jsxS("div", {
    ...props1,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "wj_0"),
    ref: rootRef
  }, null, 0, "wj_1");
}, "AccordionRoot_component_g2zmhgM0zEM"));
const AccordionItem = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const props1 = qwik._restProps(props, [
    "defaultValue",
    "id"
  ]);
  const localId = qwik.useId();
  const itemId = props.id || localId;
  const isTriggerExpandedSig = qwik.useSignal(props.defaultValue ?? false);
  const itemContext = {
    itemId,
    isTriggerExpandedSig,
    defaultValue: props.defaultValue ?? false
  };
  qwik.useContextProvider(accordionItemContextId, itemContext);
  return /* @__PURE__ */ qwik._jsxS("div", {
    "data-item-id": itemId,
    id: itemId,
    ...props1,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "Pi_0")
  }, {
    "data-type": "item"
  }, 0, "Pi_1");
}, "AccordionItem_component_3CQPU1jSYdI"));
const AccordionHeader = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const props1 = qwik._restProps(props, [
    "as"
  ]);
  const itemContext = qwik.useContext(accordionItemContextId);
  const headerId = `${itemContext.itemId}-header`;
  return /* @__PURE__ */ qwik._jsxC(props.as ?? "h3", {
    id: headerId,
    ...props1,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "Ex_0")
  }, 0, "Ex_1");
}, "AccordionHeader_component_FUrAbPilwsg"));
let KeyCode;
(function(KeyCode2) {
  KeyCode2["ArrowLeft"] = "ArrowLeft";
  KeyCode2["ArrowRight"] = "ArrowRight";
  KeyCode2["ArrowUp"] = "ArrowUp";
  KeyCode2["ArrowDown"] = "ArrowDown";
  KeyCode2["Home"] = "Home";
  KeyCode2["End"] = "End";
  KeyCode2["PageUp"] = "PageUp";
  KeyCode2["PageDown"] = "PageDown";
  KeyCode2["Enter"] = "Enter";
})(KeyCode || (KeyCode = {}));
const accordionPreventedKeys = [
  KeyCode.Home,
  KeyCode.End,
  KeyCode.PageDown,
  KeyCode.PageUp,
  KeyCode.ArrowDown,
  KeyCode.ArrowUp
];
const AccordionTrigger = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const props1 = qwik._restProps(props, [
    "disabled"
  ]);
  const contextService = qwik.useContext(accordionRootContextId);
  const itemContext = qwik.useContext(accordionItemContextId);
  const ref = qwik.useSignal();
  const triggerId = `${itemContext.itemId}-trigger`;
  const contentId = `${itemContext.itemId}-content`;
  const setSelectedTriggerIndexSig$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [contextService2, ref2] = qwik.useLexicalScope();
    if (contextService2.behavior === "single" && ref2.value)
      contextService2.currSelectedTriggerIndexSig.value = contextService2.triggerElementsSig.value.indexOf(ref2.value);
  }, "AccordionTrigger_component_setSelectedTriggerIndexSig_0OSOlkTfu0o", [
    contextService,
    ref
  ]);
  const setCurrFocusedIndexSig$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [contextService2, ref2] = qwik.useLexicalScope();
    if (!ref2.value)
      return;
    contextService2.currFocusedTriggerIndexSig.value = contextService2.triggerElementsSig.value.indexOf(ref2.value);
  }, "AccordionTrigger_component_setCurrFocusedIndexSig_Ojp60zAFieU", [
    contextService,
    ref
  ]);
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function resetTriggersTask({ track }) {
    const [contextService2, itemContext2, triggerId2] = qwik.useLexicalScope();
    track(() => contextService2.selectedTriggerIdSig.value);
    if (contextService2.behavior === "single" && triggerId2 !== contextService2.selectedTriggerIdSig.value)
      itemContext2.isTriggerExpandedSig.value = false;
  }, "AccordionTrigger_component_useTask_WCAhDdl0NEs", [
    contextService,
    itemContext,
    triggerId
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function openDefaultValueTask() {
    const [itemContext2] = qwik.useLexicalScope();
    if (itemContext2.defaultValue)
      itemContext2.isTriggerExpandedSig.value = true;
  }, "AccordionTrigger_component_useTask_1_DhCTE0BMbTw", [
    itemContext
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function navigateTriggerVisibleTask({ cleanup }) {
    const [contextService2, props2, ref2] = qwik.useLexicalScope();
    if (!ref2.value)
      return;
    if (!props2.disabled)
      contextService2.updateTriggers$();
    function keyHandler(e) {
      if (accordionPreventedKeys.includes(e.key))
        e.preventDefault();
    }
    ref2.value.addEventListener("keydown", keyHandler);
    cleanup(() => {
      ref2.value?.removeEventListener("keydown", keyHandler);
    });
  }, "AccordionTrigger_component_useVisibleTask_jzAWm2wRxvc", [
    contextService,
    props,
    ref
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function cleanupTriggersTask({ cleanup }) {
    const [contextService2] = qwik.useLexicalScope();
    cleanup(() => {
      contextService2.updateTriggers$();
    });
  }, "AccordionTrigger_component_useVisibleTask_1_0ddh5AIQpZ4", [
    contextService
  ]), {
    strategy: "document-ready"
  });
  return /* @__PURE__ */ qwik._jsxS("button", {
    "aria-controls": contentId,
    "data-trigger-id": triggerId,
    id: triggerId,
    ref,
    ...props1,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "w8_0"),
    onClick$: [
      /* @__PURE__ */ qwik.inlinedQrl(() => {
        const [contextService2, itemContext2, setSelectedTriggerIndexSig$2, triggerId2] = qwik.useLexicalScope();
        contextService2.selectedTriggerIdSig.value = triggerId2;
        setSelectedTriggerIndexSig$2();
        contextService2.collapsible ? itemContext2.isTriggerExpandedSig.value = !itemContext2.isTriggerExpandedSig.value : itemContext2.isTriggerExpandedSig.value = true;
      }, "AccordionTrigger_component_button_onClick_wFmRl2CNkhA", [
        contextService,
        itemContext,
        setSelectedTriggerIndexSig$,
        triggerId
      ]),
      props1.onClick$
    ],
    onFocus$: [
      setCurrFocusedIndexSig$,
      props1.onFocus$
    ],
    onKeyDown$: [
      /* @__PURE__ */ qwik.inlinedQrl(async (e) => {
        const [contextService2] = qwik.useLexicalScope();
        if (e.key === "ArrowUp")
          await contextService2.focusPreviousTrigger$();
        if (e.key === "ArrowDown")
          await contextService2.focusNextTrigger$();
        if (e.key === "Home")
          await contextService2.focusFirstTrigger$();
        if (e.key === "End")
          await contextService2.focusLastTrigger$();
      }, "AccordionTrigger_component_button_onKeyDown_LR3SOQYfX0E", [
        contextService
      ]),
      props1.onKeyDown$
    ]
  }, {
    "aria-disabled": qwik._fnSignal((p0) => p0.disabled, [
      props
    ], "p0.disabled"),
    "aria-expanded": qwik._fnSignal((p0) => p0.isTriggerExpandedSig.value, [
      itemContext
    ], "p0.isTriggerExpandedSig.value"),
    "data-state": qwik._fnSignal((p0) => p0.isTriggerExpandedSig.value ? "open" : "closed", [
      itemContext
    ], 'p0.isTriggerExpandedSig.value?"open":"closed"'),
    disabled: qwik._fnSignal((p0) => p0.disabled, [
      props
    ], "p0.disabled")
  }, 0, "w8_1");
}, "AccordionTrigger_component_AJeKjAu9hO8"));
const AccordionContent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl(({ ...props }) => {
  const contextService = qwik.useContext(accordionRootContextId);
  const itemContext = qwik.useContext(accordionItemContextId);
  const ref = qwik.useSignal();
  const contentId = `${itemContext.itemId}-content`;
  const totalHeightSig = qwik.useSignal(0);
  const isContentHiddenSig = qwik.useSignal(!itemContext.defaultValue);
  const hideContent$ = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [isContentHiddenSig2, itemContext2] = qwik.useLexicalScope();
    if (!itemContext2.isTriggerExpandedSig.value)
      isContentHiddenSig2.value = true;
  }, "AccordionContent_component_hideContent_E0ulDHGvHLo", [
    isContentHiddenSig,
    itemContext
  ]);
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(`
    /* check global.css utilites layer for animation */
    @keyframes accordion-open {
      0% {
        height: 0;
      }
      100% {
        height: var(--qwikui-accordion-content-height);
      }
    }
  
    @keyframes accordion-close {
        0% {
          height: var(--qwikui-accordion-content-height);
        }
        100% {
          height: 0;
        }
      }
  `, "AccordionContent_component_useStylesScoped_QNx2IJLoU24"));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function animateContentTask({ track }) {
    const [contextService2, isContentHiddenSig2, itemContext2] = qwik.useLexicalScope();
    if (!contextService2.animated)
      return;
    track(() => itemContext2.isTriggerExpandedSig.value);
    if (itemContext2.isTriggerExpandedSig.value)
      isContentHiddenSig2.value = false;
  }, "AccordionContent_component_useTask_VKRGCrNePOM", [
    contextService,
    isContentHiddenSig,
    itemContext
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(function calculateHeightVisibleTask({ track }) {
    const [contextService2, isContentHiddenSig2, ref2, totalHeightSig2] = qwik.useLexicalScope();
    if (contextService2.animated === false)
      return;
    track(() => isContentHiddenSig2.value);
    if (totalHeightSig2.value === 0)
      getCalculatedHeight();
    function getCalculatedHeight() {
      if (!ref2.value)
        return;
      const contentChildren = Array.from(ref2.value.children);
      contentChildren.forEach((element, index) => {
        totalHeightSig2.value += element.offsetHeight;
        if (index === contentChildren.length - 1)
          ref2.value.style.setProperty("--qwikui-accordion-content-height", `${totalHeightSig2.value}px`);
      });
    }
  }, "AccordionContent_component_useVisibleTask_uE46wteULcY", [
    contextService,
    isContentHiddenSig,
    ref,
    totalHeightSig
  ]));
  return /* @__PURE__ */ qwik._jsxS("div", {
    "data-content-id": contentId,
    id: contentId,
    ref,
    ...props,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "Jh_0"),
    onAnimationEnd$: [
      hideContent$,
      props.onAnimationEnd$
    ],
    onTransitionEnd$: [
      hideContent$,
      props.onTransitionEnd$
    ]
  }, {
    "data-state": qwik._fnSignal((p0) => p0.isTriggerExpandedSig.value ? "open" : "closed", [
      itemContext
    ], 'p0.isTriggerExpandedSig.value?"open":"closed"'),
    hidden: qwik._fnSignal((p0, p1, p2) => p0.animated ? p1.value : !p2.isTriggerExpandedSig.value, [
      contextService,
      isContentHiddenSig,
      itemContext
    ], "p0.animated?p1.value:!p2.isTriggerExpandedSig.value"),
    role: "region",
    style: {
      ["--qwikui-collapsible-content-height"]: "var(--qwikui-accordion-content-height)",
      ["--qwikui-collapsible-content-width"]: "var(--qwikui-accordion-content-width)"
    }
  }, 0, "Jh_1");
}, "AccordionContent_component_dMPR3hdoMUQ"));
exports.AccordionContent = AccordionContent;
exports.AccordionHeader = AccordionHeader;
exports.AccordionItem = AccordionItem;
exports.AccordionRoot = AccordionRoot;
exports.AccordionTrigger = AccordionTrigger;
exports._auto_accordionPreventedKeys = accordionPreventedKeys;
exports.accordionItemContextId = accordionItemContextId;
exports.accordionRootContextId = accordionRootContextId;
